ext InitVram_
ext InitSprites_, UpdateSprites
ext InitSound_, SoundHandler
ext Main_

Interval equ 117

dseg
TimerCount: 
    defb 0


cseg
Startup: public Startup
    lda #$ff | defb $53,$01 ; tam ; I/O
    lda #$f8 | defb $53,$02 ; tam ; RAM
    lda #$00 | defb $53,$80 ; tam ; ROM
    lda #$01 | defb $53,$20 ; tam ; ROM
    lda #$02 | defb $53,$40 ; tam ; ROM

    jsr InitVram_
    jsr InitSprites_
    jsr InitSound_

    sei
        lda #Interval | sta $0c00
        lda #$01 | sta $0c01
        lda $1402 | and #not $06 | sta $1402
    cli
jmp Main_


VHandler: public VHandler
    pha
    defb $da ; phx
    defb $5a ; phy
        lda >$0000
        and #$20
        if ne
            jsr UpdateSprites
        endif
    defb $7a ; ply
    defb $fa ; plx
    pla
rti


THandler: public THandler
    pha
    defb $da ; phx
    defb $5a ; phy
        defb $9c | defw $1403 ; stz        
        lda #Interval | sta $0c00
        lda #$01 | sta $0c01

        inc TimerCount
        jsr SoundHandler
    defb $7a ; ply
    defb $fa ; plx        
    pla
rti


; void WaitTimer(byte t);
dseg
WaitTimer_@Param0: public WaitTimer_@Param0
    defb 0
cseg
WaitTimer_: public WaitTimer_
    pha
        do
            lda TimerCount
            cmp WaitTimer_@Param0
        while cc | wend
        sei
            lda #0 | sta TimerCount
        cli
    pla
rts
