#include "Vram.h"
#include "Chars.h"

extern void _deb();
extern byte[] MonoPattern, LinePattern, ColorPattern;

void InitVram()
{
    InitVdc();
    InitColors();
    InitMonoChar(Char_Ascii, MonoPattern, 64, 7);
    InitMonoChar(Char_Logo, MonoPattern + Char_Logo * CharHeight, 16, 14);
    InitMonoChar(Char_Soil, MonoPattern + Char_Soil * CharHeight, 2, 0xae);
    InitMonoChar(Char_Bedrock, MonoPattern + Char_Bedrock * CharHeight, 1, 0x1f);
    InitMonoChar(Char_Wall, MonoPattern + Char_Wall * CharHeight, 9, 14);
    InitColorChar(Char_Remain, ColorPattern, Char_End - Char_Remain);
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


void Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}


void Erase2(word vram)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, Char_Space);
        }
        vram += VramRowSize - 2 * VramStep;
    }
}


void Put2S(word vram, ptr<byte> pChars)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, *pChars);
            ++pChars;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}
